import { CanActivate, CanDeactivate, Router, UrlTree, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';
import { CollectionService } from './collection.service';
import { FireAuthService } from '../auth/auth.service';
import { QueryFn } from '@angular/fire/firestore';
import { EntityState } from '@datorama/akita';
import { FireAuthState } from '../auth/auth.model';
export interface CollectionRouteData {
    queryFn: QueryFn;
    redirect: string;
    awaitSync: boolean;
}
export declare function CollectionGuardConfig(data: Partial<CollectionRouteData>): (constructor: any) => void;
declare type GuardService<S extends EntityState<any> | FireAuthState> = S extends FireAuthState ? FireAuthService<S> : S extends EntityState ? CollectionService<S> : never;
export declare class CollectionGuard<S extends EntityState<any> | FireAuthState = any> implements CanActivate, CanDeactivate<any> {
    protected service: GuardService<S>;
    private subscription;
    protected router: Router;
    constructor(service: GuardService<S>);
    /** Should the guard wait for connection to Firestore to complete */
    protected readonly awaitSync: boolean;
    /** A queryFn to execute for sync */
    protected readonly queryFn: QueryFn;
    /** The route to redirect to if you sync failed */
    protected readonly redirect: string;
    /** The method to subscribe to while route is active */
    protected sync(next: ActivatedRouteSnapshot, state: RouterStateSnapshot): Observable<any>;
    canActivate(next: ActivatedRouteSnapshot, state: RouterStateSnapshot): Promise<boolean | UrlTree>;
    canDeactivate(): boolean;
}
export {};
